<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactSearchRow StructType
 * @subpackage Structs
 */
class ContactSearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ContactSearchRowBasic
     */
    public $basic;
    /**
     * The callJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PhoneCallSearchRowBasic
     */
    public $callJoin;
    /**
     * The campaignResponseJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CampaignSearchRowBasic
     */
    public $campaignResponseJoin;
    /**
     * The caseJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SupportCaseSearchRowBasic
     */
    public $caseJoin;
    /**
     * The customerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerSearchRowBasic
     */
    public $customerJoin;
    /**
     * The customerPrimaryJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerSearchRowBasic
     */
    public $customerPrimaryJoin;
    /**
     * The eventJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CalendarEventSearchRowBasic
     */
    public $eventJoin;
    /**
     * The fileJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\FileSearchRowBasic
     */
    public $fileJoin;
    /**
     * The jobJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\JobSearchRowBasic
     */
    public $jobJoin;
    /**
     * The jobPrimaryJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\JobSearchRowBasic
     */
    public $jobPrimaryJoin;
    /**
     * The messagesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchRowBasic
     */
    public $messagesJoin;
    /**
     * The messagesFromJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchRowBasic
     */
    public $messagesFromJoin;
    /**
     * The messagesToJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchRowBasic
     */
    public $messagesToJoin;
    /**
     * The opportunityJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OpportunitySearchRowBasic
     */
    public $opportunityJoin;
    /**
     * The parentCustomerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerSearchRowBasic
     */
    public $parentCustomerJoin;
    /**
     * The parentJobJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\JobSearchRowBasic
     */
    public $parentJobJoin;
    /**
     * The parentPartnerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PartnerSearchRowBasic
     */
    public $parentPartnerJoin;
    /**
     * The parentVendorJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\VendorSearchRowBasic
     */
    public $parentVendorJoin;
    /**
     * The partnerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PartnerSearchRowBasic
     */
    public $partnerJoin;
    /**
     * The partnerPrimaryJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PartnerSearchRowBasic
     */
    public $partnerPrimaryJoin;
    /**
     * The purchasedItemJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ItemSearchRowBasic
     */
    public $purchasedItemJoin;
    /**
     * The taskJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TaskSearchRowBasic
     */
    public $taskJoin;
    /**
     * The transactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchRowBasic
     */
    public $transactionJoin;
    /**
     * The upsellItemJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ItemSearchRowBasic
     */
    public $upsellItemJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $userJoin;
    /**
     * The userNotesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\NoteSearchRowBasic
     */
    public $userNotesJoin;
    /**
     * The vendorJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\VendorSearchRowBasic
     */
    public $vendorJoin;
    /**
     * The vendorPrimaryJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\VendorSearchRowBasic
     */
    public $vendorPrimaryJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchRowBasic[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for ContactSearchRow
     * @uses ContactSearchRow::setBasic()
     * @uses ContactSearchRow::setCallJoin()
     * @uses ContactSearchRow::setCampaignResponseJoin()
     * @uses ContactSearchRow::setCaseJoin()
     * @uses ContactSearchRow::setCustomerJoin()
     * @uses ContactSearchRow::setCustomerPrimaryJoin()
     * @uses ContactSearchRow::setEventJoin()
     * @uses ContactSearchRow::setFileJoin()
     * @uses ContactSearchRow::setJobJoin()
     * @uses ContactSearchRow::setJobPrimaryJoin()
     * @uses ContactSearchRow::setMessagesJoin()
     * @uses ContactSearchRow::setMessagesFromJoin()
     * @uses ContactSearchRow::setMessagesToJoin()
     * @uses ContactSearchRow::setOpportunityJoin()
     * @uses ContactSearchRow::setParentCustomerJoin()
     * @uses ContactSearchRow::setParentJobJoin()
     * @uses ContactSearchRow::setParentPartnerJoin()
     * @uses ContactSearchRow::setParentVendorJoin()
     * @uses ContactSearchRow::setPartnerJoin()
     * @uses ContactSearchRow::setPartnerPrimaryJoin()
     * @uses ContactSearchRow::setPurchasedItemJoin()
     * @uses ContactSearchRow::setTaskJoin()
     * @uses ContactSearchRow::setTransactionJoin()
     * @uses ContactSearchRow::setUpsellItemJoin()
     * @uses ContactSearchRow::setUserJoin()
     * @uses ContactSearchRow::setUserNotesJoin()
     * @uses ContactSearchRow::setVendorJoin()
     * @uses ContactSearchRow::setVendorPrimaryJoin()
     * @uses ContactSearchRow::setCustomSearchJoin()
     * @param \StructType\ContactSearchRowBasic $basic
     * @param \StructType\PhoneCallSearchRowBasic $callJoin
     * @param \StructType\CampaignSearchRowBasic $campaignResponseJoin
     * @param \StructType\SupportCaseSearchRowBasic $caseJoin
     * @param \StructType\CustomerSearchRowBasic $customerJoin
     * @param \StructType\CustomerSearchRowBasic $customerPrimaryJoin
     * @param \StructType\CalendarEventSearchRowBasic $eventJoin
     * @param \StructType\FileSearchRowBasic $fileJoin
     * @param \StructType\JobSearchRowBasic $jobJoin
     * @param \StructType\JobSearchRowBasic $jobPrimaryJoin
     * @param \StructType\MessageSearchRowBasic $messagesJoin
     * @param \StructType\MessageSearchRowBasic $messagesFromJoin
     * @param \StructType\MessageSearchRowBasic $messagesToJoin
     * @param \StructType\OpportunitySearchRowBasic $opportunityJoin
     * @param \StructType\CustomerSearchRowBasic $parentCustomerJoin
     * @param \StructType\JobSearchRowBasic $parentJobJoin
     * @param \StructType\PartnerSearchRowBasic $parentPartnerJoin
     * @param \StructType\VendorSearchRowBasic $parentVendorJoin
     * @param \StructType\PartnerSearchRowBasic $partnerJoin
     * @param \StructType\PartnerSearchRowBasic $partnerPrimaryJoin
     * @param \StructType\ItemSearchRowBasic $purchasedItemJoin
     * @param \StructType\TaskSearchRowBasic $taskJoin
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @param \StructType\ItemSearchRowBasic $upsellItemJoin
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @param \StructType\VendorSearchRowBasic $vendorJoin
     * @param \StructType\VendorSearchRowBasic $vendorPrimaryJoin
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     */
    public function __construct(\StructType\ContactSearchRowBasic $basic = null, \StructType\PhoneCallSearchRowBasic $callJoin = null, \StructType\CampaignSearchRowBasic $campaignResponseJoin = null, \StructType\SupportCaseSearchRowBasic $caseJoin = null, \StructType\CustomerSearchRowBasic $customerJoin = null, \StructType\CustomerSearchRowBasic $customerPrimaryJoin = null, \StructType\CalendarEventSearchRowBasic $eventJoin = null, \StructType\FileSearchRowBasic $fileJoin = null, \StructType\JobSearchRowBasic $jobJoin = null, \StructType\JobSearchRowBasic $jobPrimaryJoin = null, \StructType\MessageSearchRowBasic $messagesJoin = null, \StructType\MessageSearchRowBasic $messagesFromJoin = null, \StructType\MessageSearchRowBasic $messagesToJoin = null, \StructType\OpportunitySearchRowBasic $opportunityJoin = null, \StructType\CustomerSearchRowBasic $parentCustomerJoin = null, \StructType\JobSearchRowBasic $parentJobJoin = null, \StructType\PartnerSearchRowBasic $parentPartnerJoin = null, \StructType\VendorSearchRowBasic $parentVendorJoin = null, \StructType\PartnerSearchRowBasic $partnerJoin = null, \StructType\PartnerSearchRowBasic $partnerPrimaryJoin = null, \StructType\ItemSearchRowBasic $purchasedItemJoin = null, \StructType\TaskSearchRowBasic $taskJoin = null, \StructType\TransactionSearchRowBasic $transactionJoin = null, \StructType\ItemSearchRowBasic $upsellItemJoin = null, \StructType\EmployeeSearchRowBasic $userJoin = null, \StructType\NoteSearchRowBasic $userNotesJoin = null, \StructType\VendorSearchRowBasic $vendorJoin = null, \StructType\VendorSearchRowBasic $vendorPrimaryJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setCallJoin($callJoin)
            ->setCampaignResponseJoin($campaignResponseJoin)
            ->setCaseJoin($caseJoin)
            ->setCustomerJoin($customerJoin)
            ->setCustomerPrimaryJoin($customerPrimaryJoin)
            ->setEventJoin($eventJoin)
            ->setFileJoin($fileJoin)
            ->setJobJoin($jobJoin)
            ->setJobPrimaryJoin($jobPrimaryJoin)
            ->setMessagesJoin($messagesJoin)
            ->setMessagesFromJoin($messagesFromJoin)
            ->setMessagesToJoin($messagesToJoin)
            ->setOpportunityJoin($opportunityJoin)
            ->setParentCustomerJoin($parentCustomerJoin)
            ->setParentJobJoin($parentJobJoin)
            ->setParentPartnerJoin($parentPartnerJoin)
            ->setParentVendorJoin($parentVendorJoin)
            ->setPartnerJoin($partnerJoin)
            ->setPartnerPrimaryJoin($partnerPrimaryJoin)
            ->setPurchasedItemJoin($purchasedItemJoin)
            ->setTaskJoin($taskJoin)
            ->setTransactionJoin($transactionJoin)
            ->setUpsellItemJoin($upsellItemJoin)
            ->setUserJoin($userJoin)
            ->setUserNotesJoin($userNotesJoin)
            ->setVendorJoin($vendorJoin)
            ->setVendorPrimaryJoin($vendorPrimaryJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\ContactSearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\ContactSearchRowBasic $basic
     * @return \StructType\ContactSearchRow
     */
    public function setBasic(\StructType\ContactSearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get callJoin value
     * @return \StructType\PhoneCallSearchRowBasic|null
     */
    public function getCallJoin()
    {
        return $this->callJoin;
    }
    /**
     * Set callJoin value
     * @param \StructType\PhoneCallSearchRowBasic $callJoin
     * @return \StructType\ContactSearchRow
     */
    public function setCallJoin(\StructType\PhoneCallSearchRowBasic $callJoin = null)
    {
        $this->callJoin = $callJoin;
        return $this;
    }
    /**
     * Get campaignResponseJoin value
     * @return \StructType\CampaignSearchRowBasic|null
     */
    public function getCampaignResponseJoin()
    {
        return $this->campaignResponseJoin;
    }
    /**
     * Set campaignResponseJoin value
     * @param \StructType\CampaignSearchRowBasic $campaignResponseJoin
     * @return \StructType\ContactSearchRow
     */
    public function setCampaignResponseJoin(\StructType\CampaignSearchRowBasic $campaignResponseJoin = null)
    {
        $this->campaignResponseJoin = $campaignResponseJoin;
        return $this;
    }
    /**
     * Get caseJoin value
     * @return \StructType\SupportCaseSearchRowBasic|null
     */
    public function getCaseJoin()
    {
        return $this->caseJoin;
    }
    /**
     * Set caseJoin value
     * @param \StructType\SupportCaseSearchRowBasic $caseJoin
     * @return \StructType\ContactSearchRow
     */
    public function setCaseJoin(\StructType\SupportCaseSearchRowBasic $caseJoin = null)
    {
        $this->caseJoin = $caseJoin;
        return $this;
    }
    /**
     * Get customerJoin value
     * @return \StructType\CustomerSearchRowBasic|null
     */
    public function getCustomerJoin()
    {
        return $this->customerJoin;
    }
    /**
     * Set customerJoin value
     * @param \StructType\CustomerSearchRowBasic $customerJoin
     * @return \StructType\ContactSearchRow
     */
    public function setCustomerJoin(\StructType\CustomerSearchRowBasic $customerJoin = null)
    {
        $this->customerJoin = $customerJoin;
        return $this;
    }
    /**
     * Get customerPrimaryJoin value
     * @return \StructType\CustomerSearchRowBasic|null
     */
    public function getCustomerPrimaryJoin()
    {
        return $this->customerPrimaryJoin;
    }
    /**
     * Set customerPrimaryJoin value
     * @param \StructType\CustomerSearchRowBasic $customerPrimaryJoin
     * @return \StructType\ContactSearchRow
     */
    public function setCustomerPrimaryJoin(\StructType\CustomerSearchRowBasic $customerPrimaryJoin = null)
    {
        $this->customerPrimaryJoin = $customerPrimaryJoin;
        return $this;
    }
    /**
     * Get eventJoin value
     * @return \StructType\CalendarEventSearchRowBasic|null
     */
    public function getEventJoin()
    {
        return $this->eventJoin;
    }
    /**
     * Set eventJoin value
     * @param \StructType\CalendarEventSearchRowBasic $eventJoin
     * @return \StructType\ContactSearchRow
     */
    public function setEventJoin(\StructType\CalendarEventSearchRowBasic $eventJoin = null)
    {
        $this->eventJoin = $eventJoin;
        return $this;
    }
    /**
     * Get fileJoin value
     * @return \StructType\FileSearchRowBasic|null
     */
    public function getFileJoin()
    {
        return $this->fileJoin;
    }
    /**
     * Set fileJoin value
     * @param \StructType\FileSearchRowBasic $fileJoin
     * @return \StructType\ContactSearchRow
     */
    public function setFileJoin(\StructType\FileSearchRowBasic $fileJoin = null)
    {
        $this->fileJoin = $fileJoin;
        return $this;
    }
    /**
     * Get jobJoin value
     * @return \StructType\JobSearchRowBasic|null
     */
    public function getJobJoin()
    {
        return $this->jobJoin;
    }
    /**
     * Set jobJoin value
     * @param \StructType\JobSearchRowBasic $jobJoin
     * @return \StructType\ContactSearchRow
     */
    public function setJobJoin(\StructType\JobSearchRowBasic $jobJoin = null)
    {
        $this->jobJoin = $jobJoin;
        return $this;
    }
    /**
     * Get jobPrimaryJoin value
     * @return \StructType\JobSearchRowBasic|null
     */
    public function getJobPrimaryJoin()
    {
        return $this->jobPrimaryJoin;
    }
    /**
     * Set jobPrimaryJoin value
     * @param \StructType\JobSearchRowBasic $jobPrimaryJoin
     * @return \StructType\ContactSearchRow
     */
    public function setJobPrimaryJoin(\StructType\JobSearchRowBasic $jobPrimaryJoin = null)
    {
        $this->jobPrimaryJoin = $jobPrimaryJoin;
        return $this;
    }
    /**
     * Get messagesJoin value
     * @return \StructType\MessageSearchRowBasic|null
     */
    public function getMessagesJoin()
    {
        return $this->messagesJoin;
    }
    /**
     * Set messagesJoin value
     * @param \StructType\MessageSearchRowBasic $messagesJoin
     * @return \StructType\ContactSearchRow
     */
    public function setMessagesJoin(\StructType\MessageSearchRowBasic $messagesJoin = null)
    {
        $this->messagesJoin = $messagesJoin;
        return $this;
    }
    /**
     * Get messagesFromJoin value
     * @return \StructType\MessageSearchRowBasic|null
     */
    public function getMessagesFromJoin()
    {
        return $this->messagesFromJoin;
    }
    /**
     * Set messagesFromJoin value
     * @param \StructType\MessageSearchRowBasic $messagesFromJoin
     * @return \StructType\ContactSearchRow
     */
    public function setMessagesFromJoin(\StructType\MessageSearchRowBasic $messagesFromJoin = null)
    {
        $this->messagesFromJoin = $messagesFromJoin;
        return $this;
    }
    /**
     * Get messagesToJoin value
     * @return \StructType\MessageSearchRowBasic|null
     */
    public function getMessagesToJoin()
    {
        return $this->messagesToJoin;
    }
    /**
     * Set messagesToJoin value
     * @param \StructType\MessageSearchRowBasic $messagesToJoin
     * @return \StructType\ContactSearchRow
     */
    public function setMessagesToJoin(\StructType\MessageSearchRowBasic $messagesToJoin = null)
    {
        $this->messagesToJoin = $messagesToJoin;
        return $this;
    }
    /**
     * Get opportunityJoin value
     * @return \StructType\OpportunitySearchRowBasic|null
     */
    public function getOpportunityJoin()
    {
        return $this->opportunityJoin;
    }
    /**
     * Set opportunityJoin value
     * @param \StructType\OpportunitySearchRowBasic $opportunityJoin
     * @return \StructType\ContactSearchRow
     */
    public function setOpportunityJoin(\StructType\OpportunitySearchRowBasic $opportunityJoin = null)
    {
        $this->opportunityJoin = $opportunityJoin;
        return $this;
    }
    /**
     * Get parentCustomerJoin value
     * @return \StructType\CustomerSearchRowBasic|null
     */
    public function getParentCustomerJoin()
    {
        return $this->parentCustomerJoin;
    }
    /**
     * Set parentCustomerJoin value
     * @param \StructType\CustomerSearchRowBasic $parentCustomerJoin
     * @return \StructType\ContactSearchRow
     */
    public function setParentCustomerJoin(\StructType\CustomerSearchRowBasic $parentCustomerJoin = null)
    {
        $this->parentCustomerJoin = $parentCustomerJoin;
        return $this;
    }
    /**
     * Get parentJobJoin value
     * @return \StructType\JobSearchRowBasic|null
     */
    public function getParentJobJoin()
    {
        return $this->parentJobJoin;
    }
    /**
     * Set parentJobJoin value
     * @param \StructType\JobSearchRowBasic $parentJobJoin
     * @return \StructType\ContactSearchRow
     */
    public function setParentJobJoin(\StructType\JobSearchRowBasic $parentJobJoin = null)
    {
        $this->parentJobJoin = $parentJobJoin;
        return $this;
    }
    /**
     * Get parentPartnerJoin value
     * @return \StructType\PartnerSearchRowBasic|null
     */
    public function getParentPartnerJoin()
    {
        return $this->parentPartnerJoin;
    }
    /**
     * Set parentPartnerJoin value
     * @param \StructType\PartnerSearchRowBasic $parentPartnerJoin
     * @return \StructType\ContactSearchRow
     */
    public function setParentPartnerJoin(\StructType\PartnerSearchRowBasic $parentPartnerJoin = null)
    {
        $this->parentPartnerJoin = $parentPartnerJoin;
        return $this;
    }
    /**
     * Get parentVendorJoin value
     * @return \StructType\VendorSearchRowBasic|null
     */
    public function getParentVendorJoin()
    {
        return $this->parentVendorJoin;
    }
    /**
     * Set parentVendorJoin value
     * @param \StructType\VendorSearchRowBasic $parentVendorJoin
     * @return \StructType\ContactSearchRow
     */
    public function setParentVendorJoin(\StructType\VendorSearchRowBasic $parentVendorJoin = null)
    {
        $this->parentVendorJoin = $parentVendorJoin;
        return $this;
    }
    /**
     * Get partnerJoin value
     * @return \StructType\PartnerSearchRowBasic|null
     */
    public function getPartnerJoin()
    {
        return $this->partnerJoin;
    }
    /**
     * Set partnerJoin value
     * @param \StructType\PartnerSearchRowBasic $partnerJoin
     * @return \StructType\ContactSearchRow
     */
    public function setPartnerJoin(\StructType\PartnerSearchRowBasic $partnerJoin = null)
    {
        $this->partnerJoin = $partnerJoin;
        return $this;
    }
    /**
     * Get partnerPrimaryJoin value
     * @return \StructType\PartnerSearchRowBasic|null
     */
    public function getPartnerPrimaryJoin()
    {
        return $this->partnerPrimaryJoin;
    }
    /**
     * Set partnerPrimaryJoin value
     * @param \StructType\PartnerSearchRowBasic $partnerPrimaryJoin
     * @return \StructType\ContactSearchRow
     */
    public function setPartnerPrimaryJoin(\StructType\PartnerSearchRowBasic $partnerPrimaryJoin = null)
    {
        $this->partnerPrimaryJoin = $partnerPrimaryJoin;
        return $this;
    }
    /**
     * Get purchasedItemJoin value
     * @return \StructType\ItemSearchRowBasic|null
     */
    public function getPurchasedItemJoin()
    {
        return $this->purchasedItemJoin;
    }
    /**
     * Set purchasedItemJoin value
     * @param \StructType\ItemSearchRowBasic $purchasedItemJoin
     * @return \StructType\ContactSearchRow
     */
    public function setPurchasedItemJoin(\StructType\ItemSearchRowBasic $purchasedItemJoin = null)
    {
        $this->purchasedItemJoin = $purchasedItemJoin;
        return $this;
    }
    /**
     * Get taskJoin value
     * @return \StructType\TaskSearchRowBasic|null
     */
    public function getTaskJoin()
    {
        return $this->taskJoin;
    }
    /**
     * Set taskJoin value
     * @param \StructType\TaskSearchRowBasic $taskJoin
     * @return \StructType\ContactSearchRow
     */
    public function setTaskJoin(\StructType\TaskSearchRowBasic $taskJoin = null)
    {
        $this->taskJoin = $taskJoin;
        return $this;
    }
    /**
     * Get transactionJoin value
     * @return \StructType\TransactionSearchRowBasic|null
     */
    public function getTransactionJoin()
    {
        return $this->transactionJoin;
    }
    /**
     * Set transactionJoin value
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @return \StructType\ContactSearchRow
     */
    public function setTransactionJoin(\StructType\TransactionSearchRowBasic $transactionJoin = null)
    {
        $this->transactionJoin = $transactionJoin;
        return $this;
    }
    /**
     * Get upsellItemJoin value
     * @return \StructType\ItemSearchRowBasic|null
     */
    public function getUpsellItemJoin()
    {
        return $this->upsellItemJoin;
    }
    /**
     * Set upsellItemJoin value
     * @param \StructType\ItemSearchRowBasic $upsellItemJoin
     * @return \StructType\ContactSearchRow
     */
    public function setUpsellItemJoin(\StructType\ItemSearchRowBasic $upsellItemJoin = null)
    {
        $this->upsellItemJoin = $upsellItemJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @return \StructType\ContactSearchRow
     */
    public function setUserJoin(\StructType\EmployeeSearchRowBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get userNotesJoin value
     * @return \StructType\NoteSearchRowBasic|null
     */
    public function getUserNotesJoin()
    {
        return $this->userNotesJoin;
    }
    /**
     * Set userNotesJoin value
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @return \StructType\ContactSearchRow
     */
    public function setUserNotesJoin(\StructType\NoteSearchRowBasic $userNotesJoin = null)
    {
        $this->userNotesJoin = $userNotesJoin;
        return $this;
    }
    /**
     * Get vendorJoin value
     * @return \StructType\VendorSearchRowBasic|null
     */
    public function getVendorJoin()
    {
        return $this->vendorJoin;
    }
    /**
     * Set vendorJoin value
     * @param \StructType\VendorSearchRowBasic $vendorJoin
     * @return \StructType\ContactSearchRow
     */
    public function setVendorJoin(\StructType\VendorSearchRowBasic $vendorJoin = null)
    {
        $this->vendorJoin = $vendorJoin;
        return $this;
    }
    /**
     * Get vendorPrimaryJoin value
     * @return \StructType\VendorSearchRowBasic|null
     */
    public function getVendorPrimaryJoin()
    {
        return $this->vendorPrimaryJoin;
    }
    /**
     * Set vendorPrimaryJoin value
     * @param \StructType\VendorSearchRowBasic $vendorPrimaryJoin
     * @return \StructType\ContactSearchRow
     */
    public function setVendorPrimaryJoin(\StructType\VendorSearchRowBasic $vendorPrimaryJoin = null)
    {
        $this->vendorPrimaryJoin = $vendorPrimaryJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchRowBasic[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $contactSearchRowCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$contactSearchRowCustomSearchJoinItem instanceof \StructType\CustomSearchRowBasic) {
                $invalidValues[] = is_object($contactSearchRowCustomSearchJoinItem) ? get_class($contactSearchRowCustomSearchJoinItem) : sprintf('%s(%s)', gettype($contactSearchRowCustomSearchJoinItem), var_export($contactSearchRowCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     * @return \StructType\ContactSearchRow
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic $item
     * @return \StructType\ContactSearchRow
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchRowBasic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchRowBasic) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
